#include <lynx.h>
#include <lynxlib.h>
#include <global.h>
#include <joypad.h>

// have to have stuff before first //

// Moon Patrol for Lynx
// Jum Hig 2000

/* __ALWAYS__ use both defines but using is recommended for shorter code */
#define FIXARGC         /* be sure you don't use <8 arguments ! */
#define NOARGC

#define	BUFFER1	0x9000

/*************** for VSYNC handling*******************/
uchar frames, lines;

extern uchar VBLflag;
#asm
_VBLflag = $a0
#endasm

#define VSYNC {++VBLflag;while( VBLflag );}

/*************** sprites *****************************/
extern uchar SCB1[];
extern uchar SCB2[];
extern uchar SCB3[];
extern uchar SCB4[];
extern uchar SCB5[];
extern uchar SCB5b[];
extern uchar SCB6[];
extern uchar SCB6b[];
extern uchar SCB7[];
extern uchar SCB7b[];
extern uchar SCB8[];
extern uchar SCB9[];
extern uchar SCB10[];
extern uchar SCBclr[];
extern uchar SCBp1[];					// heli
extern uchar SCBfire1[];
extern uchar SCBfire2[];
extern uchar SCBfire3[];
extern uchar SCBfire4[];


/*************** samples ****************************/
//extern uchar starkick[];

extern char buggy[];
extern char bwheel1[];
extern char bwheel2[];
extern char swheel1[];
extern char swheel2[];
extern char hills[];
extern char mntn[];
extern char ground[];
extern char moon[];					// "Moon" text
extern char runner[];				// "Runner" text
extern char fireup[];				// vertical bullet
extern char hfire[];				// horizontal bullet
extern char srock[];
extern char brock[];

#asm

_SCBclr	dc.b $c1,$10,$20				;; clear lines 0 -> 101
		dc.w _SCB5,_sprclr
		dc.w $100,20,$a000,$6600
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_sprclr	dc.b $03, $08, $00, $00

_SCB1	dc.b $c4,$10,$20				;; buggy
		dc.w _SCB2,_buggy
		dc.w $140,32,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB2	dc.b $c5,$18,$20				;; wheel1
		dc.w _SCB3,_bwheel1
		dc.w $140,39,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB3	dc.b $c5,$18,$20
		dc.w _SCB4,_bwheel1					;; wheel2
		dc.w $146,39,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB4	dc.b $c5,$18,$20
		dc.w 0,_swheel1						;; wheel3
		dc.w $14E,39,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB5	dc.b $c1,$10,$20					;; mountains (1)
		dc.w _SCB5b,_mntn
		dc.w 0,64,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB5b	dc.b $c1,$10,$20					;; mountains (2)
		dc.w _SCB6,_mntn
		dc.w $100,64,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB6	dc.b $c5,$18,$20					;; hills (1)
		dc.w _SCB6b,_hills
		dc.w 0,72,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB6b	dc.b $c5,$18,$20					;; hills (2)
		dc.w _SCB7,_hills
		dc.w $100,72,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB7	dc.b $c1,$18,$20
		dc.w _SCB7b,_ground					;; ground (1)
		dc.w 0,104,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB7b	dc.b $c1,$18,$20
		dc.w _SCB8,_ground					;; ground (2)
		dc.w $100,104,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB8	dc.b $c5,$14,$20					;; title 1
		dc.w _SCB9,_moon
		dc.w $130,22,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef

_SCB9	dc.b $c5,$14,$20					;; title 2
		dc.w _SCBfire1,_runner
		dc.w $127,46,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef


;; fire (bullets)

_SCBfire1	dc.b $c4,$14,$20
		dc.w _SCBfire2,_fireup					;; fire up
		dc.w $100,$20,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef
			
_SCBfire2	dc.b $c4,$14,$20
		dc.w _SCBfire3,_fireup					;; fire up
		dc.w $100,$30,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef
			
_SCBfire3	dc.b $c4,$14,$20
		dc.w _SCBfire4,_fireup					;; fire up
		dc.w $100,$40,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef
			
_SCBfire4	dc.b $c4,$14,$20
		dc.w _SCB1,_hfire						;; fire right
		dc.w $100,$50,$100,$100
		dc.b $01, $23, $45, $67, $89,$Ab,$cd,$ef


#endasm

#include "work.pal"				// work palette
#include "pal.pal"				// main game pal
#include "bgcol.pal"			// bg colours for every line (HBL)

#include "hmap.h"				// height map for ground
#include "sin.h"				// sintable 0 -> 127 -> 0-> -127 -> 0

// checkerboard fade
void fade_checker(void) {
	uchar *i;
	int j;
	int k;
	i = ScreenBuffer;
	
	for(j=0; j<4; j++) {
		for(k=0; k < 8160; k += 4) {
			*(i+k+j) = 0;
		}
	}
}

// reset work pal to black
void reset_workpal(void) {
	uchar x;
	for(x=0; x<32; x++) workpal[x] = 0x00;
}

// fade work palette to
void fade_in(void) {
	uchar x, y, c, d;
	
	// fade in to required palette
	for(y=0; y<16; y++) {
		for(x=0; x<16 ; x++) {
			if(workpal[x] < pal[x]) workpal[x]++;
			d = c = workpal[x+16];
			c &= 0xF0;
			d &= 0x0F;
			if(c < (pal[x+16] & 0xF0)) c += 0x10;
			if(d < (pal[x+16] & 0x0F)) d += 0x01;
			workpal[x+16] = c+d;
		}
		VSYNC; VSYNC;
		_SetRGB(workpal);
	}
}

// fade out palette
void fade_out(void) {
	uchar x, y, c, d;

	// copy pal to workpal
	for(x=0; x<32; x++) {
		workpal[x] = pal[x];
	}
	
	// fade out palette
	for(y=15; y ; y--) {
		for(x=0; x<16 ; x++) {
			if(workpal[x]) workpal[x]--;
			d = c = workpal[x+16];
			c &= 0xF0;
			d &= 0x0F;
			if(c) c -= 0x10;
			if(d) d -= 0x01;
			workpal[x+16] = c+d;
		}
		VSYNC; VSYNC;
		_SetRGB(workpal);
	}
}

// read joystick
uchar joypad(void)
{
	return PEEK(0xFCB0);
}

// Vertical "blank" interrupt routine
VBL() interrupt
{
	VBLflag = 0; /* indicates that a VBL has ocurred */
	lines = 0;				// hopefully optimised
	frames++;
}

// Horizontal "blank" interrupt routine
// note: get cycle count!
HBL() interrupt
{
#asm

ch_clr	pha
		phx
		ldx	_lines
		inc _lines
		inc _lines
		lda _bgcol,x
		sta	$FDA0
		lda _bgcol+1,x
		sta $FDB0
		plx
		pla
#endasm
}

// ******************** MAIN *************************
main() {
	zstatic char t1;
	uchar uc, htotal, jumping, bx, gnd_dx;
	uchar fire[4], fire_x[4], fire_y[4];
	uchar fire_prev;

	// debug
	uchar fb, fcount;
	
	char dx;
	zstatic uchar buggy_x, buggy_y;
	zstatic uchar w1y, w2y, w3y, w_anim;		// wheel y's and anim
	zstatic uint heli_x, heli_y;

	uchar i, j, x ,y ,c ,d;
	uint hill1x, hill2x, mntn1x, mntn2x, bg_x;
	uint gnd_x;
	int *pdata;
	uchar *firedata[4];
	
	InitIRQ();
	InstallIRQ(2,VBL);
	InstallIRQ(0,HBL);
	EnableIRQ(2); /* 42BS */
	//EnableIRQ(0);
	CLI;
	frames = 0;

	SetBuffers(BUFFER1,0,0);

	// reset palette
	reset_workpal();
	_SetRGB(workpal);
	VSYNC;
	DrawSprite(SCB1);
	
	// fade in screen
	fade_in();

	// debug - goto start
	goto start;
	
	// display title screen while moving copter up the screen
	x = 120;
	while(x != 30) {
  		SCB2[9] = x;
  		SCB3[9] = x - 4;
  		SCB4[9] = x - 4;
  		y = x % 2;
  		if(y) { SCB3[1] = 0x18 ; SCB4[1] = 0x14; }
  		else { SCB3[1] = 0x14 ; SCB4[1] = 0x18; }
   		VSYNC;
  		DrawSprite(SCB1);
  		x--;
	};

	// wait for A or B button to start
	// keep rotors rotating
	while((joystick & 0x03) == 0) {
  		y = x % 2;
		if(y) { SCB3[1] = 0x18 ; SCB4[1] = 0x14; }
		else { SCB3[1] = 0x14 ; SCB4[1] = 0x18; }
		VSYNC;
		DrawSprite(SCB1);
		x--;
	}

	// fade screen out checkerboard effect
	//fade_checker();

	// fade out palette
	fade_out();

start:
	//SmpInit(0,1);				// channel 0, timer 1
	//EnableIRQ(1);    /* use a macro defined in lynxlib.h */
	//SmpStart(starkick, 20);

	// set H_OFF, V_OFF for sprites to 256, 20
	asm(" pha\n"\
		" lda #$00\n"\
		" sta $FC04\n"\
		" lda #$01\n"\
		" sta $FC05\n"\
		" lda #20\n"\
		" sta $FC06\n"\
		" lda #$00\n"\
		" sta $FC07\n"\
		" pla");

	_SetRGB(pal);
	EnableIRQ(0);

	hill1x = 0x100; hill2x = 0x200;
	mntn1x = 0x100; mntn2x = 0x200;
	gnd_x = 0x400;

// all sprite coordinates in 10:6 fixed pt.
// for smooth-scrolling background etc.
	heli_y = 32 << 6; heli_x = 200 << 6;
	bx = 80;											// buggy_x * 2
	jumping = 0;
	for(j=0;j<4;j++) { fire[j] = 0; fire_x[j] = 0; fire_y[j] = 0; }
	firedata[0] = SCBfire1;
	firedata[1] = SCBfire2;
	firedata[2] = SCBfire3;
	firedata[3] = SCBfire4;
	gnd_dx = 1;

// debug sound stuff
// NB: shift bits must be written before counter started.
// NB: all values reset to 0 at reset (eg: attenX)
// NB: at least one feedback tap must be on to get a sound.
mstereo = 0xFF;
//1. set preselector
channelB.control = 0x04;				// 16ms timer
//2. set reload value
channelB.reload = 141;					// "backup" (reload) value
//3. Set bit pattern
channelB.other = 0xC0;					// 50% duty cycle in shift bits
channelB.shiftlo = 0xCC;
//3.5 set feedback
channelB.feedback = 0x01;
//4. Set volume register
channelB.volume = 99;
//5. Set counter initial value (valid for write?)
channelB.count = 142;
//6. Start counter
channelB.control = 0x1C;				// enable reload,count. 16ms timer
//7. Set panning and stereo channel switch
//panning = 0x00;
mstereo = 0x00;

fb = 1;
fcount = 200;

	while(1) {
		// get joystick;
		j = joystick;

		// move background
		//bg_x = buggy_x >> 3;
		bg_x = gnd_x >> 2;
		hill1x = (bg_x) & 0x1ff;				// ASM these !
		hill2x = (bg_x + 0x100) & 0x1ff;
		//bg_x = buggy_x >> 2;
		bg_x = gnd_x >> 3;
		mntn1x = (bg_x) & 0x1ff;
		mntn2x = (bg_x + 0x100) & 0x1ff;
		SCBX(SCB5) = mntn1x;
		SCBX(SCB5b) = mntn2x;
		SCBX(SCB6) = hill1x;
		SCBX(SCB6b) = hill2x;
		

		// move ground
		gnd_x -= gnd_dx;
		SCBX(SCB7) = (gnd_x & 0x01FF);
		SCBX(SCB7b) = ((gnd_x + 0x0100) & 0x01FF);

		// move buggy
		if(jumping) {
			jumping -= 2;
			buggy_y = 92 - ((sin[jumping] & 0x7f) >> 3);		// jump buggy
			w1y = buggy_y + 6;					// put wheels up
			if(bx < 160) bx += dx;				// move forward (if not at limit)
			else if(dx == 2) gnd_dx = 2;		// accelerate if jumping through limit
			buggy_x = (bx >> 1);
			SCBX(SCB1) = 0x100 + buggy_x;
			SCBY(SCB1) = buggy_y;
			SCBX(SCB2) = 0x100 + buggy_x;
			SCBY(SCB2) = w1y;
			SCBX(SCB3) = 0x106 + buggy_x;
			SCBY(SCB3) = w1y;
			SCBX(SCB4) = 0x10E + buggy_x;
			SCBY(SCB4) = w1y;
		}
		else {						// not jumping
			dx = 0;
			gnd_dx = 1;
			
			if(j & JOY_RIGHT) {
				dx = 2;
				if(bx < 160) bx += dx;							// move buggy
				else gnd_dx = 2;								// OR accelerate ground
			}
			else if(j & JOY_LEFT) {
				dx = -1;
				bx += dx;
			}
			if(j & BTN_B) jumping = 126;						// jump
			buggy_x = (bx >> 1);
			buggy_y = 92;
			htotal = 0;
			uc = 0xFF - ((gnd_x-buggy_x-2) & 0xFF);				// find x-pos on hmap
			w1y = buggy_y + 6 + hmap[uc];
			htotal += hmap[uc];
			uc = 0xFF - ((gnd_x-buggy_x-8) & 0xFF);				// find x-pos on hmap
			w2y = buggy_y + 6 + hmap[uc];
			htotal += hmap[uc];
			uc = 0xFF - ((gnd_x-buggy_x-16) & 0xFF);				// find x-pos on hmap
			w3y = buggy_y + 6 + hmap[uc];
			htotal += hmap[uc];
			buggy_y += (htotal >> 2);						// adjust buggy height
			SCBX(SCB1) = 0x100 + buggy_x;
			SCBY(SCB1) = buggy_y;
			SCBX(SCB2) = 0x100 + buggy_x;
			SCBY(SCB2) = w1y;
			SCBX(SCB3) = 0x106 + buggy_x;
			SCBY(SCB3) = w2y;
			SCBX(SCB4) = 0x10E + buggy_x;
			SCBY(SCB4) = w3y;
		} // end if jumping/not jumping
		if(bx < 4) bx = 4;									// prevent offscreen

		// check fire
		fcount--; if(fcount == 8) fcount = 200;
		channelB.reload = fcount;
		if((j & BTN_A) && !fire_prev) {
			// change feedback
			fb++;
			channelB.feedback = fb;
			
			// vertical shots
			for(i=0;i<3;i++) {				// find first free bullet
				if(!fire[i]) {
					fire[i] = 64;
					fire_y[i] = buggy_y - 4;
					SCBX(firedata[i]) = 0x106 + buggy_x;
					SCBCTL1(firedata[i]) = 0x18;			// sprite skip off
					i = 4;
				}
			}
			// horizontal shot
			if(!fire[3]) {
				fire[3] = 64;
				fire_x[3] = buggy_x + 20;
				SCBY(firedata[3]) = buggy_y + 4;
				SCBCTL1(firedata[3]) = 0x18;			// sprite skip off
			}
		} // end if fire
		fire_prev = (j & BTN_A);						// prevent autofire :)

		// animate wheels
		if(w_anim++ & 0x04) {
			SCBDATA(SCB2) = bwheel1;
			SCBDATA(SCB3) = bwheel1;
			SCBDATA(SCB4) = swheel1;
		}
		else {
			SCBDATA(SCB2) = bwheel2;
			SCBDATA(SCB3) = bwheel2;
			SCBDATA(SCB4) = swheel2;
		}

		// move missiles
		// vertical shots
		for(i=0;i<3;i++) {
			if(fire[i]) {
				fire_y[i] -= 4;
				SCBY(firedata[i]) = fire_y[i];
				if(fire_y[i] < 16) {
					fire[i] = 0;
					SCBCTL1(firedata[i]) = 0x14;			// sprite skip on
				}
			}
		}
		// horizontal shot
		if(fire[3]) {
			fire_x[3] += 4;
			SCBX(firedata[3]) = 0x100 + fire_x[3];
			if(fire_x[3] > 156) {
				fire[3] = 0;
				SCBCTL1(firedata[3]) = 0x14;			// sprite skip on
			}
		}

		// sync draw
		VSYNC;
		VSYNC;
		 
		DrawSprite(SCBclr);
	} // end while
	
  for(;;);

}
